| OpenCV 3.4.7 Open Source Computer Vision

Public Member Functions | Public Attributes | List of all members
cv::dnn::Layer Class Reference
Deep Neural Network module

This interface class allows to build new Layers - are building blocks of networks. More...

`#include <opencv2/dnn/dnn.hpp>`

Inheritance diagram for cv::dnn::Layer:

## Public Member Functions
| Layer ()
| Layer (const LayerParams &params)
| Initializes only name, type and blobs fields. More...
virtual | ~Layer ()
virtual void | applyHalideScheduler (Ptr< BackendNode > &node, const std::vector< Mat *> &inputs, const std::vector< Mat > &outputs, int targetId) const
| Automatic Halide scheduling based on layer hyper-parameters. More...
virtual void | finalize (const std::vector< Mat *> &input, std::vector< Mat > &output)
| Computes and sets internal parameters according to inputs, outputs and blobs. More...
virtual void | finalize (InputArrayOfArrays inputs, OutputArrayOfArrays outputs)
| Computes and sets internal parameters according to inputs, outputs and blobs. More...
void | finalize (const std::vector< Mat > &inputs, std::vector< Mat > &outputs)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. More...
std::vector< Mat > | finalize (const std::vector< Mat > &inputs)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. More...
virtual void | forward (std::vector< Mat *> &input, std::vector< Mat > &output, std::vector< Mat > &internals)
| Given the `input` blobs, computes the output `blobs`. More...
virtual void | forward (InputArrayOfArrays inputs, OutputArrayOfArrays outputs, OutputArrayOfArrays internals)
| Given the `input` blobs, computes the output `blobs`. More...
void | forward_fallback (InputArrayOfArrays inputs, OutputArrayOfArrays outputs, OutputArrayOfArrays internals)
| Given the `input` blobs, computes the output `blobs`. More...
virtual int64 | getFLOPS (const std::vector< MatShape > &inputs, const std::vector< MatShape > &outputs) const
virtual bool | getMemoryShapes (const std::vector< MatShape > &inputs, const int requiredOutputs, std::vector< MatShape > &outputs, std::vector< MatShape > &internals) const
virtual void | getScaleShift (Mat &scale, Mat &shift) const
| Returns parameters of layers with channel-wise multiplication and addition. More...
virtual Ptr< BackendNode > | initHalide (const std::vector< Ptr< BackendWrapper > > &inputs)
| Returns Halide backend node. More...
virtual Ptr< BackendNode > | initInfEngine (const std::vector< Ptr< BackendWrapper > > &inputs)
virtual int | inputNameToIndex (String inputName)
| Returns index of input blob into the input array. More...
virtual int | outputNameToIndex (const String &outputName)
| Returns index of output blob in output array. More...
void | run (const std::vector< Mat > &inputs, std::vector< Mat > &outputs, std::vector< Mat > &internals)
| Allocates layer and computes output. More...
virtual bool | setActivation (const Ptr< ActivationLayer > &layer)
| Tries to attach to the layer the subsequent activation layer, i.e. do the layer fusion in a partial case. More...
void | setParamsFrom (const LayerParams &params)
| Initializes only name, type and blobs fields. More...
virtual bool | supportBackend (int backendId)
| Ask layer if it support specific backend for doing computations. More...
virtual Ptr< BackendNode > | tryAttach (const Ptr< BackendNode > &node)
| Implement layers fusing. More...
virtual bool | tryFuse (Ptr< Layer > &top)
| Try to fuse current layer with a next one. More...
virtual void | unsetAttached ()
| "Deattaches" all the layers, attached to particular layer. More...
Public Member Functions inherited from cv::Algorithm
| Algorithm ()
virtual | ~Algorithm ()
virtual void | clear ()
| Clears the algorithm state. More...
virtual bool | empty () const
| Returns true if the Algorithm is empty (e.g. in the very beginning or after unsuccessful read. More...
virtual String | getDefaultName () const
virtual void | read (const FileNode &fn)
| Reads algorithm parameters from a file storage. More...
virtual void | save (const String &filename) const
virtual void | write (FileStorage &fs) const
| Stores algorithm parameters in a file storage. More...
void | write (const Ptr< FileStorage > &fs, const String &name=String()) const
| simplified API for language bindings This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. More...

## Public Attributes
std::vector< Mat > | blobs
| List of learned parameters must be stored here to allow read them by using Net::getParam(). More...
String | name
| Name of the layer instance, can be used for logging or other internal purposes. More...
int | preferableTarget
| prefer target for layer forwarding More...
String | type
| Type name which was used for creating layer by layer factory. More...

## Additional Inherited Members
Static Public Member Functions inherited from cv::Algorithm
template<typename _Tp >
static Ptr< _Tp > | load (const String &filename, const String &objname=String())
| Loads algorithm from the file. More...
template<typename _Tp >
static Ptr< _Tp > | loadFromString (const String &strModel, const String &objname=String())
| Loads algorithm from a String. More...
template<typename _Tp >
static Ptr< _Tp > | read (const FileNode &fn)
| Reads algorithm from the file node. More...
Protected Member Functions inherited from cv::Algorithm
void | writeFormat (FileStorage &fs) const

## Detailed Description

This interface class allows to build new Layers - are building blocks of networks.

Each class, derived from Layer, must implement allocate() methods to declare own outputs and forward() to compute outputs. Also before using the new layer into networks you must register your layer by using one of LayerFactory macros.

## Constructor & Destructor Documentation

## § Layer() [1/2]

cv::dnn::Layer::Layer | ( |  | ) |

## § Layer() [2/2]

cv::dnn::Layer::Layer | ( | const LayerParams & | params | ) |
| explicit

Initializes only name, type and blobs fields.

## § ~Layer()

virtual cv::dnn::Layer::~Layer | ( |  | ) |
| virtual

## Member Function Documentation

## § applyHalideScheduler()

virtual void cv::dnn::Layer::applyHalideScheduler | ( | Ptr< BackendNode > & | node,
|  | const std::vector< Mat *> & | inputs,
|  | const std::vector< Mat > & | outputs,
|  | int | targetId
| ) |  | const
| virtual

Automatic Halide scheduling based on layer hyper-parameters.

Parameters

  [in] | node | Backend node with Halide functions.
  [in] | inputs | Blobs that will be used in forward invocations.
  [in] | outputs | Blobs that will be used in forward invocations.
  [in] | targetId | Target identifier

See also
  BackendNode, Target

Layer don't use own Halide::Func members because we can have applied layers fusing. In this way the fused function should be scheduled.

## § finalize() [1/4]

virtual void cv::dnn::Layer::finalize | ( | const std::vector< Mat *> & | input,
|  | std::vector< Mat > & | output
| ) |  |
| virtual

Python:
| outputs | = | cv.dnn_Layer.finalize( | inputs[, outputs] | )

Computes and sets internal parameters according to inputs, outputs and blobs.

Deprecated:
  Use Layer::finalize(InputArrayOfArrays, OutputArrayOfArrays) instead

Parameters

  [in] | input | vector of already allocated input blobs
  [out] | output | vector of already allocated output blobs

If this method is called after network has allocated all memory for input and output blobs and before inferencing.

## § finalize() [2/4]

virtual void cv::dnn::Layer::finalize | ( | InputArrayOfArrays | inputs,
|  | OutputArrayOfArrays | outputs
| ) |  |
| virtual

Python:
| outputs | = | cv.dnn_Layer.finalize( | inputs[, outputs] | )

Computes and sets internal parameters according to inputs, outputs and blobs.

Parameters

  [in] | inputs | vector of already allocated input blobs
  [out] | outputs | vector of already allocated output blobs

If this method is called after network has allocated all memory for input and output blobs and before inferencing.

## § finalize() [3/4]

void cv::dnn::Layer::finalize | ( | const std::vector< Mat > & | inputs,
|  | std::vector< Mat > & | outputs
| ) |  |

Python:
| outputs | = | cv.dnn_Layer.finalize( | inputs[, outputs] | )

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Deprecated:
  Use Layer::finalize(InputArrayOfArrays, OutputArrayOfArrays) instead

## § finalize() [4/4]

std::vector<Mat> cv::dnn::Layer::finalize | ( | const std::vector< Mat > & | inputs | ) |

Python:
| outputs | = | cv.dnn_Layer.finalize( | inputs[, outputs] | )

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Deprecated:
  Use Layer::finalize(InputArrayOfArrays, OutputArrayOfArrays) instead

## § forward() [1/2]

virtual void cv::dnn::Layer::forward | ( | std::vector< Mat *> & | input,
|  | std::vector< Mat > & | output,
|  | std::vector< Mat > & | internals
| ) |  |
| virtual

Given the `input` blobs, computes the output `blobs`.

Deprecated:
  Use Layer::forward(InputArrayOfArrays, OutputArrayOfArrays, OutputArrayOfArrays) instead

Parameters

  [in] | input | the input blobs.
  [out] | output | allocated output blobs, which will store results of the computation.
  [out] | internals | allocated internal blobs

## § forward() [2/2]

virtual void cv::dnn::Layer::forward | ( | InputArrayOfArrays | inputs,
|  | OutputArrayOfArrays | outputs,
|  | OutputArrayOfArrays | internals
| ) |  |
| virtual

Given the `input` blobs, computes the output `blobs`.

Parameters

  [in] | inputs | the input blobs.
  [out] | outputs | allocated output blobs, which will store results of the computation.
  [out] | internals | allocated internal blobs

## § forward_fallback()

void cv::dnn::Layer::forward_fallback | ( | InputArrayOfArrays | inputs,
|  | OutputArrayOfArrays | outputs,
|  | OutputArrayOfArrays | internals
| ) |  |

Given the `input` blobs, computes the output `blobs`.

Parameters

  [in] | inputs | the input blobs.
  [out] | outputs | allocated output blobs, which will store results of the computation.
  [out] | internals | allocated internal blobs

## § getFLOPS()

virtual int64 cv::dnn::Layer::getFLOPS | ( | const std::vector< MatShape > & | inputs,
|  | const std::vector< MatShape > & | outputs
| ) |  | const
| inline virtual

## § getMemoryShapes()

virtual bool cv::dnn::Layer::getMemoryShapes | ( | const std::vector< MatShape > & | inputs,
|  | const int | requiredOutputs,
|  | std::vector< MatShape > & | outputs,
|  | std::vector< MatShape > & | internals
| ) |  | const
| virtual

## § getScaleShift()

virtual void cv::dnn::Layer::getScaleShift | ( | Mat & | scale,
|  | Mat & | shift
| ) |  | const
| virtual

Returns parameters of layers with channel-wise multiplication and addition.

Parameters

  [out] | scale | Channel-wise multipliers. Total number of values should be equal to number of channels.
  [out] | shift | Channel-wise offsets. Total number of values should be equal to number of channels.

Some layers can fuse their transformations with further layers. In example, convolution + batch normalization. This way base layer use weights from layer after it. Fused layer is skipped. By default, `scale` and `shift` are empty that means layer has no element-wise multiplications or additions.

## § initHalide()

virtual Ptr<BackendNode> cv::dnn::Layer::initHalide | ( | const std::vector< Ptr< BackendWrapper > > & | inputs | ) |
| virtual

Returns Halide backend node.

Parameters

  [in] | inputs | Input Halide buffers.

See also
  BackendNode, BackendWrapper

Input buffers should be exactly the same that will be used in forward invocations. Despite we can use Halide::ImageParam based on input shape only, it helps prevent some memory management issues (if something wrong, Halide tests will be failed).

## § initInfEngine()

virtual Ptr<BackendNode> cv::dnn::Layer::initInfEngine | ( | const std::vector< Ptr< BackendWrapper > > & | inputs | ) |
| virtual

## § inputNameToIndex()

virtual int cv::dnn::Layer::inputNameToIndex | ( | String | inputName | ) |
| virtual

Returns index of input blob into the input array.

Parameters

  inputName | label of input blob

Each layer input and output can be labeled to easily identify them using "%<layer_name%>[.output_name]" notation. This method maps label of input blob to its index into input vector.

Reimplemented in cv::dnn::LSTMLayer.

## § outputNameToIndex()

virtual int cv::dnn::Layer::outputNameToIndex | ( | const String & | outputName | ) |
| virtual

Python:
| retval | = | cv.dnn_Layer.outputNameToIndex( | outputName | )

Returns index of output blob in output array.

See also
  inputNameToIndex()

Reimplemented in cv::dnn::LSTMLayer.

## § run()

void cv::dnn::Layer::run | ( | const std::vector< Mat > & | inputs,
|  | std::vector< Mat > & | outputs,
|  | std::vector< Mat > & | internals
| ) |  |

Python:
| outputs, internals | = | cv.dnn_Layer.run( | inputs, internals[, outputs] | )

Allocates layer and computes output.

Deprecated:
  This method will be removed in the future release.

## § setActivation()

virtual bool cv::dnn::Layer::setActivation | ( | const Ptr< ActivationLayer > & | layer | ) |
| virtual

Tries to attach to the layer the subsequent activation layer, i.e. do the layer fusion in a partial case.

Parameters

  [in] | layer | The subsequent activation layer.

Returns true if the activation layer has been attached successfully.

## § setParamsFrom()

void cv::dnn::Layer::setParamsFrom | ( | const LayerParams & | params | ) |

Initializes only name, type and blobs fields.

## § supportBackend()

virtual bool cv::dnn::Layer::supportBackend | ( | int | backendId | ) |
| virtual

Ask layer if it support specific backend for doing computations.

Parameters

  [in] | backendId | computation backend identifier.

See also
  Backend

## § tryAttach()

virtual Ptr<BackendNode> cv::dnn::Layer::tryAttach | ( | const Ptr< BackendNode > & | node | ) |
| virtual

Implement layers fusing.

Parameters

  [in] | node | Backend node of bottom layer.

See also
  BackendNode

Actual for graph-based backends. If layer attached successfully, returns non-empty cv::Ptr to node of the same backend. Fuse only over the last function.

## § tryFuse()

virtual bool cv::dnn::Layer::tryFuse | ( | Ptr< Layer > & | top | ) |
| virtual

Try to fuse current layer with a next one.

Parameters

  [in] | top | Next layer to be fused.

Returns
  True if fusion was performed.

## § unsetAttached()

virtual void cv::dnn::Layer::unsetAttached | ( |  | ) |
| virtual

"Deattaches" all the layers, attached to particular layer.

## Member Data Documentation

## § blobs

std::vector<Mat> cv::dnn::Layer::blobs

List of learned parameters must be stored here to allow read them by using Net::getParam().

Examples:
  samples/dnn/colorization.cpp.

## § name

String cv::dnn::Layer::name

Name of the layer instance, can be used for logging or other internal purposes.

## § preferableTarget

int cv::dnn::Layer::preferableTarget

prefer target for layer forwarding

## § type

String cv::dnn::Layer::type

Type name which was used for creating layer by layer factory.

The documentation for this class was generated from the following file:

- opencv2/dnn/dnn.hpp